import java.applet.*;
import java.awt.*;

public class Vypocet {
  Applet app;
  Retizek guma;

  int MAXX = 600, MAXY = 200, MINX = 0, MINY = 0;
  int pocet = 20, okrajl = 1, okrajp = 1, typ = 1, kroku = 50;
  double t = 0, pruznost = 1, disipace = 1, d0 = 0, vyska = MAXY*0.1;
  boolean emitace = false, smycka = false;

  public Vypocet(Applet a, int mx, int my, int nx, int ny) {
    MAXX = mx;
    MAXY = my;
    MINX = nx;
    MINY = ny;
    app = a;
    guma = new Retizek(300, pruznost, disipace, d0);
    guma.setPocet(pocet);
    guma.srovnej(0, MAXY/2, (double)MAXX/((double)guma.getPocet()-1), 1);
  }

  public void kresli() {
    Graphics g = app.getGraphics();
    Image offscreen;
    offscreen = app.createImage(MAXX, MAXY);
    Graphics os = offscreen.getGraphics();
    guma.prepocti();
    guma.posun();
    guma.okrajL(okrajl, 0, MAXY/2);
    guma.okrajP(okrajp, MAXX, MAXY/2);
    if (emitace) {
      emituj(typ, t);
      t ++;
      if (t >= kroku) {
        t = 0;
        if (!smycka) emitace = false;
      }
    }
    guma.kresli(os);
    g.drawImage(offscreen, MINX, MINY, app);
  }

  public void srovnej() {
    guma.srovnej(0, MAXY/2, (double)MAXX/((double)guma.getPocet()-1), 1);
    kresli();
  }

  public void setPruznost(double p) {
    pruznost = p;
    guma.setPruznost(p);
  }

  public void setPocet(int p) {
    pocet = p;
    guma.setPocet(p);
    guma.srovnej(0, MAXY/2, (double)MAXX/((double)guma.getPocet()-1), 1);
    kresli();
  }

  public void setOkrajL(int o) {
    okrajl = o;
  }

  public void setOkrajP(int o) {
    okrajp = o;
  }

  public void setDisipace(double d) {
    disipace = d;
    guma.setDisipace(d);
  }

  public void setD0(double d) {
    guma.setD0(d);
  }

  public void setEmitace(boolean b, int t) {
    emitace = b;
    typ = t;
  }

  public void swapSmycka() {
    if (smycka) smycka = false;
    else smycka = true;
  }

  public void setVyska(double d) {
    vyska = d;
  }

  public void modifikace(int typ) {
    if (typ != 4) guma.modifikace(typ, pocet/3, MAXX/4, MAXY/2-5);
    else guma.modifikace(typ, pocet, MAXX, MAXY/2-5);
    kresli();
  }

  public void emituj(int typ, double t) {
    t %= kroku;
    if (typ == 1) {
      double k = 2*vyska/kroku;
      if (t < kroku) guma.okrajL(1, 0, MAXY/2 + Math.abs(-k*(t-kroku/2)) - vyska);
    }
    if (typ == 2) {
      if (t < kroku) guma.okrajL(1, 0, MAXY/2 + Math.sin(t*2*Math.PI/kroku)*vyska);
    }
    if (typ == 3) {
      if (t < kroku) guma.okrajL(1, 0, MAXY/2 + vyska);
    }
  }
}