import java.awt.*;

public class Retizek {
  Bod[] clanek;
  double pruznost, disipace, d0;
  int pocet;
  Color barva;

  public Retizek(int p, double k, double d, double dd0) {
    barva = new Color(0,0,0);
    pocet = p;
    pruznost = k;
    disipace = d;
    d0 = dd0;
    clanek = new Bod[p];
    for (int i = 0; i < pocet; i ++) {
      clanek[i] = new Bod();
    }
    srovnej(0, 0, 1, 10);
  }

  public void prepocti() {
    for (int i = 0; i < pocet-1; i ++) {
      double zrychleni, vzd, ax, ay;
      vzd = Math.sqrt((clanek[i].x - clanek[i+1].x)*(clanek[i].x - clanek[i+1].x) + (clanek[i].y - clanek[i+1].y)*(clanek[i].y - clanek[i+1].y));
      zrychleni = (vzd + d0)*pruznost/(clanek[i].m*vzd);
      ax = (clanek[i].x - clanek[i+1].x)*zrychleni;
      ay = (clanek[i].y - clanek[i+1].y)*zrychleni;
      clanek[i].vx -= ax;
      clanek[i].vy -= ay;
      clanek[i+1].vx += ax;
      clanek[i+1].vy += ay;
    }
  }

  public void posun() {
    for (int i = 0; i < pocet; i ++) {
      clanek[i].vx *= disipace;
      clanek[i].vy *= disipace;
      clanek[i].x += clanek[i].vx;
      clanek[i].y += clanek[i].vy;
    }
  }

  public void srovnej(double x, double y, double krok, double m) {
    for (int i = 0; i < pocet; i ++) {
      clanek[i].x = x + i*krok;
      clanek[i].y = y;
      clanek[i].vx = 0;
      clanek[i].vy = 0;
      clanek[i].m = m;
    }
  }

  public void okrajL(int funkce, double x, double y) {
    if (funkce == 1) {
      setBodx(0, x);
      setBody(0, y);
      setBodvx(0, 0);
      setBodvy(0, 0);
    }
    if (funkce == 2) {
      setBodx(0, x);
      setBodvx(0, 0);
    }
  }

  public void okrajP(int funkce, double x, double y) {
    if (funkce == 1) {
      setBodx(-1, x);
      setBody(-1, y);
      setBodvx(-1, 0);
      setBodvy(-1, 0);
    }
    if (funkce == 2) {
      setBodx(-1, x);
      setBodvx(-1, 0);
    }
  }

  public void sesij(int i, Bod clanek1, double x) {
    if (i < 0) i = pocet - 1;
    if (i < pocet) { 
      double zrychleni, vzd, ax, ay;
      vzd = Math.sqrt((clanek[i].x - clanek1.x)*(clanek[i].x - clanek1.x) + (clanek[i].y - clanek1.y)*(clanek[i].y - clanek1.y));
      zrychleni = (vzd + d0)*pruznost/(clanek[i].m*vzd);
      ax = (clanek[i].x - clanek1.x)*zrychleni;
      ay = (clanek[i].y - clanek1.y)*zrychleni;
      clanek[i].vx = 0;
      clanek1.vx = 0;

      clanek[i].vy -= ay;
      clanek[i].x = x;
      clanek1.vy += ay;
      clanek1.x = x;
    }
  }

  public Bod getBod(int cislo) {
    if (cislo < 0) cislo = pocet - 1;
    if ((cislo >= 0)&&(cislo < pocet)) {
      return clanek[cislo];
    }
    return clanek[0];
  }

  public void setBod(int cislo, Bod clanek1) {
    if (cislo < 0) cislo = pocet - 1;
    if ((cislo >= 0)&&(cislo < pocet)) {
      clanek[cislo].x = clanek1.x;
      clanek[cislo].y = clanek1.y;
      clanek[cislo].vx = clanek1.vx;
      clanek[cislo].vy = clanek1.vy;
    }
  }

  public void setBodx(int cislo, double x) {
    if (cislo < 0) cislo = pocet - 1;
    if ((cislo >= 0)&&(cislo < pocet)) {
      clanek[cislo].x = x;
    }
  }

  public void setBody(int cislo, double y) {
    if (cislo < 0) cislo = pocet - 1;
    if ((cislo >= 0)&&(cislo < pocet)) {
      clanek[cislo].y = y;
    }
  }

  public void setBodvx(int cislo, double vx) {
    if (cislo < 0) cislo = pocet - 1;
    if ((cislo >= 0)&&(cislo < pocet)) {
      clanek[cislo].vx = vx;
    }
  }

  public void setBodvy(int cislo, double vy) {
    if (cislo < 0) cislo = pocet - 1;
    if ((cislo >= 0)&&(cislo < pocet)) {
      clanek[cislo].vy = vy;
    }
  }

  public void setPruznost(double p) {
    pruznost = p;
  }

  public void setPocet(int p) {
    if ((p > 0)&&(p <= clanek.length)) pocet = p;
  }

  public void setDisipace(double d) {
    disipace = d;
  }

  public void setColor(Color c) {
    barva = c;
  }

  public void setD0(double d) {
    d0 = d;
  }

  public int getPocet() {
    return pocet;
  }

  public void modifikace(int typ, int mnozstvi, double delka, double vyska) {
    if ((mnozstvi <= pocet)&&(mnozstvi > 0)) {
      if (typ == 1) {
        double krok = delka/(double)mnozstvi;
        for (int i = pocet/2 - mnozstvi/2; i < pocet/2+mnozstvi/2; i ++)
          clanek[i].y += (Math.sin(2*Math.PI/(double)mnozstvi*(double)i - Math.PI/2)+1)*vyska/2;
      }
      if (typ == 2) {
        double krok = delka/(double)mnozstvi;
        for (int i = pocet/2 - mnozstvi/2; i < pocet/2+mnozstvi/2; i ++)
          if (i < pocet/2) clanek[i].y += -((double)i - (double)pocet/2 + (double)mnozstvi/2)*vyska*2/(double)mnozstvi;
          else clanek[i].y += ((double)i - (double)pocet/2 - (double)mnozstvi/2)*vyska*2/(double)mnozstvi;
      }
      if (typ == 3) {
        double krok = delka/(double)mnozstvi;
        for (int i = pocet/2 - mnozstvi/2; i < pocet/2+mnozstvi/2; i ++)
          clanek[i].y += vyska;
      }
      if (typ == 4) {
        double krok = delka/(double)mnozstvi;
        for (int i = pocet/2 - mnozstvi/2; i < pocet/2+mnozstvi/2; i ++)
          if (i < pocet/2) clanek[i].y += vyska;
          else clanek[i].y += -vyska;
      }
    }
  }

  public void kresli(Graphics g) {
    g.setColor(barva);
    for (int i = 1; i < pocet; i ++) {
      g.drawLine((int)clanek[i-1].x, (int)clanek[i-1].y, (int)clanek[i].x, (int)clanek[i].y);
    }
  }

  public void kreslis(Graphics g, int i, Bod clanek1) {
    if (i < 0) i = pocet - 1;
    if (i < pocet) {
      g.setColor(barva);
      g.drawLine((int)clanek[i].x, (int)clanek[i].y, (int)clanek1.x, (int)clanek1.y);
    }
  }
}
