import java.applet.*;
import java.awt.*;

public class Vypocet {
  Applet app;
  Retizek gumal, gumap;

  int MAXX = 600, MAXY = 200, MINX = 0, MINY = 0;
  int pocet = 200, okrajl = 1, okrajp = 1, typ = 1, kroku = 50;
  double t = 0, pruznostl = 1, pruznostp = 1, disipacep = 1, d0p = 0, vyska = MAXY*0.1;
  boolean emitace = false, smycka = false;

  public Vypocet(Applet a, int mx, int my, int nx, int ny) {
    MAXX = mx;
    MAXY = my;
    MINX = nx;
    MINY = ny;
    app = a;
    gumal = new Retizek(300, pruznostl, 1, 0);
    gumap = new Retizek(300, pruznostp, disipacep, d0p);
    gumal.setPocet(pocet);
    gumal.srovnej(0, MAXY/2, (double)MAXX/(2*((double)gumal.getPocet()-1)), 1);
    gumal.setColor(Color.blue);
    gumap.setPocet(pocet);
    gumap.srovnej(MAXX/2, MAXY/2, (double)MAXX/(2*((double)gumap.getPocet()-1)), 1);
    gumap.setColor(Color.red);
  }

  public void kresli() {
    Graphics g = app.getGraphics();
    Image offscreen;
    offscreen = app.createImage(MAXX, MAXY);
    Graphics os = offscreen.getGraphics();
    gumal.prepocti();
    gumap.prepocti();
    gumal.posun();
    gumap.posun();
    gumal.sesij(-1, gumap.getBod(0), MAXX/2);
    gumal.okrajL(okrajl, 0, MAXY/2);
    gumap.okrajP(okrajp, MAXX, MAXY/2);


    if (emitace) {
      emituj(typ, t);
      t ++;
      if (t >= kroku) {
        t = 0;
        if (!smycka) emitace = false;
      }
    }
    gumal.kresli(os);
    gumap.kresli(os);
    gumal.kreslis(os, -1, gumap.getBod(0));
    g.drawImage(offscreen, MINX, MINY, app);
  }

  public void srovnej() {
    gumal.srovnej(0, MAXY/2, (double)MAXX/(2*((double)gumal.getPocet()-1)), 1);
    gumap.srovnej(MAXX/2, MAXY/2, (double)MAXX/(2*((double)gumap.getPocet()-1)), 1);
    kresli();
  }

  public void setPruznostL(double p) {
    pruznostl = p;
    gumal.setPruznost(p);
  }

  public void setPruznostP(double p) {
    pruznostp = p;
    gumap.setPruznost(p);
  }

  public void setOkrajL(int o) {
    okrajl = o;
  }

  public void setOkrajP(int o) {
    okrajp = o;
  }

  public void setDisipace(double d) {
    disipacep = d;
    gumap.setDisipace(d);
  }

  public void setD0(double d) {
    d0p = d;
    gumap.setD0(d);
  }

  public void setEmitace(boolean b, int t) {
    emitace = b;
    typ = t;
  }

  public void swapSmycka() {
    if (smycka) smycka = false;
    else smycka = true;
  }

  public void setVyska(double d) {
    vyska = d;
  }

  public void emituj(int typ, double t) {
    t %= kroku;
    if (typ == 1) {
      double k = 2*vyska/kroku;
      if (t < kroku) gumal.okrajL(1, 0, MAXY/2 + Math.abs(-k*(t-kroku/2)) - vyska);
    }
    if (typ == 2) {
      if (t < kroku) gumal.okrajL(1, 0, MAXY/2 + Math.sin(t*2*Math.PI/kroku)*vyska);
    }
    if (typ == 3) {
      if (t < kroku) gumal.okrajL(1, 0, MAXY/2 + vyska);
    }
  }
}